%{
	#include "y.tab.h"
	#include <string.h>
	#include <stdlib.h>

	extern int lineno;

	#define YY_NO_INPUT
%}
%option nounput

%%

[ \t]+    /* ignore */;
\n        { printf("lineno++\n"); lineno++; }

"*"       return '*';
"/"       return '/';
"+"       return '+';
"-"       return '-';
"("       return '(';
")"       return ')';

0|([1-9][0-9]*) {
	yylval.intconst = atoi(yytext);
	return tINTCONST;
}

[a-zA-Z_][a-zA-Z0-9_]* { 
	yylval.stringconst = (char *)malloc(strlen(yytext) + 1);
	sprintf(yylval.stringconst, "%s", yytext); 
	return tIDENTIFIER; 
}

.       { printf("INVALID: (line %d) unknown character '%s'\n", lineno, yytext); exit(1); }
%%
