%{
	#include <stdio.h>
	#include "tree.h"

	extern char *yytext;
	extern int yylineno;
	extern EXP *expression;
	int yylex();

	void yyerror() { printf ("INVALID: (line %d) syntax error before %s\n", yylineno, yytext); }
%}

%union {
	int intconst;
	char *stringconst;
	struct EXP *exp;
}

%token <intconst> tINTCONST
%token <stringconst> tIDENTIFIER 

%type <exp> program exp

%start program

%left '+' '-'
%left '*' '/'

%% 

program: exp { expression = $1; }
;

exp : tIDENTIFIER { $$ = makeEXPid($1, @1.first_line); }
    | tINTCONST   { $$ = makeEXPintconst($1, @1.first_line); }
    | exp '*' exp { $$ = makeEXPtimes($1, $3, @2.first_line); }
    | exp '/' exp { $$ = makeEXPdiv($1, $3, @2.first_line); }
    | exp '+' exp { $$ = makeEXPplus($1, $3, @2.first_line); }
    | exp '-' exp { $$ = makeEXPminus($1, $3, @2.first_line); }
    | '(' exp ')' { $$ = $2; } 
;

%%
